SystemOrganization addCategory: #'Spec-Core'!
SystemOrganization addCategory: #'Spec-Core-Specs'!

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
getIndexSelector: aSelector

	getIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
getSelectionListSelector: getListSel.

	getSelectionListSelector := getListSel! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
initialize

	super initialize.
	self initForKeystrokes.! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setIndexSelector: aSelector

	setIndexSelector := aSelector! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setMultipleSelection: aBoolean

	multipleSelection := aBoolean! !

!PluggableListMorph methodsFor: '*Spec-Core' stamp: ''!
setSelectionListSelector: getListSel.

	setSelectionListSelector := getListSel! !

!Dictionary methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ DictionaryValueHolder contents: self! !

Model subclass: #ComposableModel
	instanceVariableNames: 'bindings focusOrder owner window widget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!ComposableModel commentStamp: '<historical>' prior: 0!
ComposableModel is an abstract which represent a applicative model made to be composed with other ComposableModel!

!ComposableModel class methodsFor: 'specs' stamp: 'bvr 6/1/2012 16:21'!
internSpec

	^ self subclassResponsibility! !

!ComposableModel class methodsFor: 'instance creation' stamp: ''!
owner: owner

	^ self new
		owner: owner;
		yourself! !

!ComposableModel class methodsFor: 'protocol' stamp: 'bvr 6/1/2012 16:22'!
specSelectors
	
	^ ((PragmaCollector filter: [:prg | prg keyword = 'spec']) reset; collected)
		select: [:e | e method methodClass = self class ] thenCollect: [:e | e method selector ]! !

!ComposableModel class methodsFor: 'specs' stamp: ''!
title
	
	^ 'Untitled window'! !

!ComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 5/22/2012 15:07'!
windowSpec

	^{ #StandardWindow.
			#addMorphBack:.	{ self internSpec .
						#layout:. {#FrameLayout.
							#fractions:offsets:. (0@0 corner: 1@1). nil	}}.
			#title:.					self title}! !

!ComposableModel methodsFor: 'private' stamp: ''!
addAll: aWindow withSpec: aSpec

	aWindow
		addMorph: (self buildWithSpec: aSpec)
		frame: (0@0 corner: 1@1).! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'StephaneDucasse 5/17/2012 19:26'!
beginsWith: aString fromList: aMorph
	"This method is used bu the list for the search of elements when you are typing directly in the list"
	
	^ false! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:31'!
bindings

	^ bindings! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:50'!
bindings: aBindings

	self bindings bindings: aBindings! !

!ComposableModel methodsFor: 'protocol' stamp: 'bvr 6/1/2012 16:34'!
buildWithSpec

	^ self buildWithSpec: self defaultSpecSelector! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 03:20'!
buildWithSpec: aSpec

	^ SpecInterpreter buildMorphFor: self withSpec: aSpec! !

!ComposableModel methodsFor: 'private' stamp: 'bvr 6/1/2012 17:12'!
defaultSpec

	^ self class perform: self defaultSpecSelector! !

!ComposableModel methodsFor: 'private' stamp: 'bvr 6/1/2012 16:34'!
defaultSpecSelector

	(((PragmaCollector filter: [:prg | prg keyword = 'spec:' and: [prg arguments includes: #default]]) reset; collected)
		select: [:e | e method methodClass = self class class ] thenCollect: [:e | e method selector ])
		ifNotEmpty: [:col | ^ col first ].

	self specSelectors
		ifNotEmpty: [:col | col size = 1 ifTrue: [ ^ col first ]].
		
	"should use pragmas"
	^ #internSpec
	
! !

!ComposableModel methodsFor: 'private' stamp: 'StephaneDucasse 5/17/2012 17:50'!
delete

	widget
		ifNotNil: [ widget owner ifNotNil: [:o | o delete ]]! !

!ComposableModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:17'!
eventStringForNextFocus
	"String describing the keystroke to perform to jump to the next widget"
	^ ''! !

!ComposableModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 18:18'!
eventStringForPreviousFocus
	"String describing the keystroke to perform to jump to the previous widget"
	^ ''! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
focusOrder

	^ focusOrder ifNil: [ focusOrder := OrderedCollection new ].! !

!ComposableModel methodsFor: 'focus' stamp: ''!
giveFocusToNextFrom: aMorph

	| focus |

	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index next |
			index := (focus indexOf: aMorph) + 1.
			(index <= focus size)
				ifTrue: [
					next := focus at: index.
					next takeKeyboardFocus.
					^ true ]].

	^ owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: 1 ifAbsent: [ ^ false ].
			next takeKeyboardFocus.
			true ]
		ifNotNil: [ 
			owner giveFocusToNextFrom: self.
			true ]! !

!ComposableModel methodsFor: 'focus' stamp: ''!
giveFocusToPreviousFrom: aMorph 

	| focus |
	focus := self focusOrder.

	(focus includes: aMorph)
		ifTrue: [
			| index previous |
			index := (focus indexOf: aMorph) - 1.
			(index > 0)
				ifTrue: [
					previous := focus at: index.
					previous takeLastKeyboardFocus.
					^ true ]].

	^ owner 
		ifNil: [ " I loop "
			| next |
			next := focus at: focus size ifAbsent: [ false ].
			next takeLastKeyboardFocus.
			true]
		ifNotNil: [ 
			owner giveFocusToPreviousFrom: self.
			true ]! !

!ComposableModel methodsFor: 'focus' stamp: ''!
handlesKeyboard: evt

	^ true! !

!ComposableModel methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/24/2012 10:31'!
initialize
	"Initialization code for ComposableModel"

	super initialize.

	bindings := BindingsHolder new.! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/22/2012 14:23'!
initializeClassesBinding

	^ IdentityDictionary new! !

!ComposableModel methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 3/22/2012 14:23'!
initializeSelectorsBinding

	^ IdentityDictionary new! !

!ComposableModel methodsFor: 'instance creation' stamp: ''!
instantiate: aComposableModelClass

	^ aComposableModelClass owner: self! !

!ComposableModel methodsFor: 'instance creation' stamp: 'bvr 6/1/2012 16:08'!
instantiateModels: aCollectionOfPairs

	aCollectionOfPairs do:[ :e |
		self instVarNamed: e key asString put: (e value owner: self) ]! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
internSpec
	<spec>
	^ self class internSpec! !

!ComposableModel methodsFor: 'focus' stamp: ''!
isEventForNextFocus: aKeyboardEvent

	^ false! !

!ComposableModel methodsFor: 'focus' stamp: ''!
isEventForPreviousFocus: aKeyboardEvent 
	
	^ false! !

!ComposableModel methodsFor: 'focus' stamp: ''!
keyStroke: anEvent fromMorph: aMorph

	((self isEventForNextFocus: anEvent) or: [ anEvent keyString = self eventStringForNextFocus])
		ifTrue: [ ^ self giveFocusToNextFrom: aMorph ].
		
	((self isEventForPreviousFocus: anEvent) or: [ anEvent keyString = self eventStringForPreviousFocus])
		ifTrue: [ ^ self giveFocusToPreviousFrom: aMorph ].
		
	^ false! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'StephaneDucasse 5/17/2012 19:29'!
listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph
	"Specify how this object as a list item should be drawn"

	widget ifNil: [ self buildWithSpec ].
	widget listRenderOn: aCanvas atRow: aRow bounds: drawBounds color: drawColor from: aMorph! !

!ComposableModel methodsFor: 'private' stamp: ''!
okToChange

	^ owner 
		ifNil: [
			self canDiscardEdits ifTrue: [^ true].
			self changed: #wantToChange.  "Solicit cancel from view"
			^ self canDiscardEdits]
		ifNotNil: [ owner okToChange ]! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
openMorphWithSpec

	^ self buildWithSpec openInWorld! !

!ComposableModel methodsFor: 'protocol' stamp: 'bvr 6/1/2012 16:34'!
openWithSpec

	^ self openWithSpec: self defaultSpecSelector.! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/9/2012 17:47'!
openWithSpec: aSpec

	window := StandardWindow new model: self.
	self addAll: window withSpec: aSpec.
	window openInWorld.
	window title: self title.
	self takeKeyboardFocus.
	^ window! !

!ComposableModel methodsFor: 'accessing' stamp: ''!
owner: anObject
	
	owner ifNotNil: [owner removeDependent: self].
	anObject ifNotNil: [anObject addDependent: self].
	owner := anObject.! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
specSelectors
	
	^ self class specSelectors! !

!ComposableModel methodsFor: 'focus' stamp: 'StephaneDucasse 5/17/2012 17:57'!
takeKeyboardFocus

	self focusOrder ifNotEmpty:[:focus | ^ focus first takeKeyboardFocus ].
	^ self widget ifNotNil: [:m | m takeKeyboardFocus ]! !

!ComposableModel methodsFor: 'focus' stamp: ''!
takeLastKeyboardFocus

	self focusOrder
		ifEmpty: [ self takeKeyboardFocus ]
		ifNotEmpty: [:focus | focus last takeKeyboardFocus ].! !

!ComposableModel methodsFor: 'protocol' stamp: ''!
title

	^ self class title! !

!ComposableModel methodsFor: 'private' stamp: ''!
update: aParameter

	self changed: aParameter! !

!ComposableModel methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/10/2012 14:01'!
updateTitle

	self window
		ifNotNil: [:w | w title: self title ]! !

!ComposableModel methodsFor: 'accessing' stamp: 'StephaneDucasse 5/17/2012 17:57'!
widget

	^ widget! !

!ComposableModel methodsFor: 'accessing' stamp: 'StephaneDucasse 5/17/2012 17:59'!
widget: anObject

	widget := anObject! !

!ComposableModel methodsFor: 'Morphic-Widgets-should-be-an-extension' stamp: 'StephaneDucasse 5/17/2012 19:29'!
widthToDisplayInList: aList
	"Return the width of my representation as a list item"
	
	widget ifNil: [ self buildWithSpec ].
	^ self widget widthToDisplayInList: aList! !

!ComposableModel methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2012 17:47'!
window

	^ window! !

!Morph methodsFor: '*Spec-Core' stamp: ''!
addMorphWrapper: aMorphWrapper
	
	
	aMorphWrapper addIn: self.! !

!Morph methodsFor: '*Spec-Core' stamp: 'bvr 6/1/2012 17:14'!
ensureLayoutAndAddMorph: aMorph

	aMorph layoutFrame
		ifNil: [ aMorph layoutFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: nil ) ].
		
	self addMorph: aMorph ! !

!SequenceableCollection methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ CollectionValueHolder contents: self! !

!LayoutFrame methodsFor: '*Spec-Core' stamp: 'bvr 6/1/2012 15:43'!
fractions: fractionsOrNil

	^ self fractions: fractionsOrNil offsets: nil! !

!LayoutFrame methodsFor: '*Spec-Core' stamp: ''!
fractions: fractionsOrNil offsets: offsetsOrNil

	| fractions offsets |

	fractions := fractionsOrNil ifNil: [0@0 extent: 0@0].
	offsets := offsetsOrNil ifNil: [0@0 extent: 0@0].
	
	^self
		topFraction: fractions top offset: offsets top;
		leftFraction: fractions left offset: offsets left;
		bottomFraction: fractions bottom offset: offsets bottom;
		rightFraction: fractions right offset: offsets right
! !

Object subclass: #AbstractSpec
	instanceVariableNames: 'instance bindings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!AbstractSpec commentStamp: '<historical>' prior: 0!
An AbstractSpec is a basic wrapper which describe a spec.

For now it can seems useless, but structural info will be stored thanks to those wrappers!

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 00:51'!
bindings

	^ bindings! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 00:51'!
bindings: anObject

	bindings := anObject! !

!AbstractSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:22'!
classSymbol

	self subclassResponsibility! !

!AbstractSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 10:47'!
defaultReceiver

	^ Smalltalk at: (self bindings retrieveClassSymbolFor: (self classSymbol))! !

!AbstractSpec methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/24/2012 10:47'!
initialize
	"Initialization code for AbstractSpec"

	super initialize.

	bindings := BindingsHolder new.! !

!AbstractSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:20'!
initializeInstance

	^ self defaultReceiver new.! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 01:19'!
instance

	^ instance ifNil: [ instance := self initializeInstance. ]! !

!AbstractSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 02:24'!
instance: anObject

	instance := anObject! !

AbstractSpec subclass: #ButtonSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ButtonSpec commentStamp: '<historical>' prior: 0!
A ButtonSpec is a spec used to describe a button!

!ButtonSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 02:48'!
classSymbol

	^ #Button! !

AbstractSpec subclass: #CheckboxSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!CheckboxSpec commentStamp: '<historical>' prior: 0!
A CheckboxSpec is a spec used to describe a CheckboxButton and a RadionButton!

!CheckboxSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:10'!
classSymbol

	^ #Checkbox! !

AbstractSpec subclass: #ComposableSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ComposableSpec commentStamp: '<historical>' prior: 0!
A ComposableSpec is a spec used to combine other specs!

!ComposableSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:42'!
classSymbol

	^ #Panel! !

!ComposableSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 10:33'!
initializeInstance

	^ SpecInterpreter 
		interpretASpec: 
			{ self classSymbol.
				#useProportionalLayout.
				#addSplitters.
				#vSpaceFill.
				#hSpaceFill.} 
		model: ComposableModel new! !

AbstractSpec subclass: #DropListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!DropListSpec commentStamp: '<historical>' prior: 0!
A DropListSpec is a spec to describe a drop list!

!DropListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:14'!
classSymbol

	^ #DropList! !

AbstractSpec subclass: #LabelSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!LabelSpec commentStamp: '<historical>' prior: 0!
A LabelSpec is a spec used to describe a label!

!LabelSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:14'!
classSymbol

	^ #Label! !

AbstractSpec subclass: #ListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!ListSpec commentStamp: '<historical>' prior: 0!
A ListSpec is a spec used to describe a list!

ListSpec subclass: #IconListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!IconListSpec commentStamp: '<historical>' prior: 0!
An IconListSpec is a spec use to describe a list with icons!

!IconListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:15'!
classSymbol

	^ #IconList! !

!ListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:21'!
classSymbol

	^ #List! !

ListSpec subclass: #MultiColumnListSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!MultiColumnListSpec commentStamp: '<historical>' prior: 0!
A MultiColumnListSpec is a spec used to describe a multi column list!

!MultiColumnListSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:15'!
classSymbol

	^ #MultiColumnList! !

AbstractSpec subclass: #RawSpec
	instanceVariableNames: 'defaultReceiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!RawSpec commentStamp: '<historical>' prior: 0!
A RawSpec is a spec used to describe whatever you want.

It simply works as a stack of interpreted symbols!

!RawSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:40'!
defaultReceiver

	^ defaultReceiver! !

!RawSpec methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 01:40'!
defaultReceiver: anObject

	defaultReceiver := anObject! !

!RawSpec methodsFor: 'accessing' stamp: 'bvr 6/1/2012 17:15'!
defaultReceiver: aSymbol model: aModel

	defaultReceiver := SpecInterpreter interpretASpec: aSymbol model: aModel.! !

!RawSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:41'!
initializeInstance

	^ self defaultReceiver! !

AbstractSpec subclass: #TextFieldSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!TextFieldSpec commentStamp: '<historical>' prior: 0!
A TextFieldSpec is a spec used to describe a text field!

!TextFieldSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:16'!
classSymbol

	^ #TextField! !

AbstractSpec subclass: #TextSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!TextSpec commentStamp: '<historical>' prior: 0!
A TextSpec is a spec used to describe a text area!

!TextSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 01:53'!
classSymbol

	^ #Text! !

AbstractSpec subclass: #TreeSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core-Specs'!

!TreeSpec commentStamp: '<historical>' prior: 0!
A TreeSpec is a spec used to describe a tree!

!TreeSpec methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/24/2012 03:17'!
classSymbol

	^ #Tree! !

Object subclass: #NewValueHolder
	instanceVariableNames: 'announcer contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!NewValueHolder commentStamp: '<historical>' prior: 0!
A NewValueHolder is a new implementation of ValueHolder based on Announcements!

NewValueHolder subclass: #CollectionValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!CollectionValueHolder commentStamp: '<historical>' prior: 0!
A CollectionValueHolder is s a value holder designed for collections!

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject

	| result |
	result := contents add: newObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject after: oldObject 
	
	| result |
	result := contents add: newObject after: oldObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject afterIndex: index 
	
	| result |
	result := contents add: newObject afterIndex: index.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject before: oldObject
	
	| result |
	result := contents add: newObject before: oldObject.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
add: newObject beforeIndex: index 
	
	| result |
	result := contents add: newObject beforeIndex: index.
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAll: aCollection 
	
	| result |
	result := contents addAll: aCollection.
	self contentsChanged: aCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllFirst: anOrderedCollection
	
	| result |
	result := contents addAllFirst: anOrderedCollection.
	self contentsChanged: anOrderedCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllFirstUnlessAlreadyPresent: anOrderedCollection
	
	| result |
	result := contents addAllFirstUnlessAlreadyPresent: anOrderedCollection.
	self contentsChanged: anOrderedCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addAllLast: aCollection 
	
	| result |
	result := contents addAllLast: aCollection.
	self contentsChanged: aCollection.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addFirst: newObject 

	| result |
	result := contents addFirst: newObject .
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
addLast: newObject 

	| result |
	result := contents addLast: newObject .
	self contentsChanged: newObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
at: index ifAbsentPut: block

	| result |
	result := contents at: index ifAbsentPut: block.
	self contentsChanged: block value.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
at: index put: value

	| result |
	result := contents at: index put: value.
	self contentsChanged: value.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAll: aCollection put: anObject 
	
	| result |
	result := contents atAll: aCollection put: anObject .
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAll: indexArray putAll: valueArray
	
	| result |
	result := contents atAll: indexArray putAll: valueArray.
	self contentsChanged: valueArray.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atAllPut: anObject 
	
	| result |
	result := contents atAllPut: anObject.
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atLast: indexFromEnd put: obj
	
	| result |
	result := contents atLast: indexFromEnd put: obj.
	self contentsChanged: obj.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
atWrap: index put: value
	
	| result |
	result := contents atWrap: index put: value.
	self contentsChanged: value.
	^ result! !

!CollectionValueHolder methodsFor: 'private' stamp: ''!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
insert: anObject before: spot

	| result |
	result := contents insert: anObject before: spot.
	self contentsChanged: anObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
remove: oldObject ifAbsent: absentBlock

	| result |
	result := contents remove: oldObject ifAbsent: absentBlock.
	self contentsChanged: oldObject.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeAll

	contents removeAll.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeAt: index

	| result |
	result := contents removeAt: index.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeFirst

	| result |
	result := contents removeFirst.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeFirst: n 

	| result |
	result := contents removeFirst: n .
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeIndex: removedIndex

	| result |
	result := contents removeIndex: removedIndex.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeLast

	| result |
	result := contents removeLast.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
removeLast: n

	| result |
	result := contents removeLast: n.
	self contentsChanged: result.
	^ result! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
replace: aBlock 

	contents replace: aBlock .
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
replaceAll: oldObject with: newObject 

	contents replaceAll: oldObject with: newObject .
	self contentsChanged: oldObject! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
reset

	contents reset.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
resetTo: index

	contents resetTo: index.
	self contentsChanged! !

!CollectionValueHolder methodsFor: 'override' stamp: ''!
size 

	^ contents size! !

!CollectionValueHolder methodsFor: 'protocol' stamp: ''!
sort: aSortBlock 

	contents sort: aSortBlock .
	self contentsChanged! !

NewValueHolder subclass: #DictionaryValueHolder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!DictionaryValueHolder commentStamp: '<historical>' prior: 0!
A DictionaryValueHolder is a value holder designed for dictionaries!

!DictionaryValueHolder methodsFor: 'override' stamp: ''!
at: anObject

	^ contents at: anObject! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
at: key ifAbsentPut: aBlock 

	contents at: key ifAbsentPut: aBlock.
	self contentsChanged: aBlock value! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
at: key put: value

	contents at: key put: value.
	self contentsChanged: value! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
atNewIndex: index put: anObject
	
	contents atNewIndex: index put: anObject.
	self contentsChanged: anObject.! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: ''!
contents

	self error: 'The contents should be accessed directly or you could break the mechanism of events'.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
doesNotUnderstand: aMessage

	^ (contents respondsTo: aMessage selector)
		ifTrue: [ contents perform: aMessage selector withEnoughArguments: aMessage arguments ]
		ifFalse: [ super doesNotUnderstand: aMessage ]! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
fillFrom: aCollection with: aBlock
	"Evaluate aBlock with each of aCollections's elements as the argument.  
	Collect the resulting values into self. Answer self."

	aCollection keysAndValuesDo: [ :key :value |
		self at: key put: (aBlock value: value) ]! !

!DictionaryValueHolder methodsFor: 'initialization' stamp: ''!
initialize
	"Initialization code for DictionaryValueHolder"

	super initialize.
	self contents: Dictionary new.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
initialize: n
	
	contents initialize: n.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeAll
	
	contents removeAll.
	self contentsChanged.! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeKey: key 
	"Remove key from the receiver.
	If key is not in the receiver, notify an error."
	
	^ self removeKey: key ifAbsent: [self errorKeyNotFound: key].! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
removeKey: key ifAbsent: aBlock 
	| result |
	
	result := contents removeKey: key ifAbsent: aBlock.
	self contentsChanged.
	^ result! !

!DictionaryValueHolder methodsFor: 'override' stamp: ''!
size 

	^ contents size! !

!DictionaryValueHolder methodsFor: 'protocol' stamp: ''!
valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary 
	
	contents valueAtNewKey: aKey put: anObject atIndex: index declareFrom: aDictionary.
	self contentsChanged.! !

!NewValueHolder class methodsFor: 'instance creation' stamp: ''!
contents: contents

	^ self new
		contents: contents;
		yourself! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
addDependent: aDependent

	self halt: 'Former API, should be changed'.! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contents

	^ contents! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contents: anObject
	
	| oldValue |
	oldValue := contents.
	contents := anObject.
	self contentsChanged: oldValue.! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged
	
	announcer announce: (ValueChanged newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged: oldValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: contents)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
contentsChanged: oldValue to: newValue
	
	announcer announce: (ValueChanged oldContents: oldValue newContents: newValue)! !

!NewValueHolder methodsFor: 'accessing' stamp: ''!
initialize

	super initialize.
	
	announcer := Announcer new! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
whenChangedDo: aBlock

	| block |
	block := [:announcement :ann | aBlock cull: announcement newContents cull: announcement oldContents cull: announcement cull: ann ].
	announcer on: ValueChanged do: block! !

!NewValueHolder methodsFor: 'announcements' stamp: ''!
whenChangedSend: aSelector to: aReceiver

	announcer on: ValueChanged send: aSelector to: aReceiver! !

NewValueHolder subclass: #SelectionValueHolder
	instanceVariableNames: 'index selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SelectionValueHolder commentStamp: '<historical>' prior: 0!
A SelectionValueHolder is a value holder especially designed to contains a list selection (an index + an object)!

!SelectionValueHolder class methodsFor: 'as yet unclassified' stamp: ''!
index: indexValueHolder selection: selectionValueHolder

	^ self new
		index: indexValueHolder;
		selection: selectionValueHolder;
		yourself! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
contents

	^ {index. selection}! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
index

	^ index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
index: anIndex

	index := anIndex.
	self changed: #index! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
initialize

	super initialize.
	index := 0 asValueHolder.
	selection := nil asValueHolder.
	
	index whenChangedSend: #contentsChanged to: self.
	selection whenChangedSend: #contentsChanged to: self.! !

!SelectionValueHolder methodsFor: 'protocol' stamp: ''!
reset

	self index contents: 0.
	self selection contents: nil.
	self contentsChanged! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
selection

	^ selection! !

!SelectionValueHolder methodsFor: 'accessing' stamp: ''!
selection: aSelection

	selection := aSelection.
	self changed: #selection! !

!Object methodsFor: '*Spec-Core' stamp: ''!
asValueHolder

	^ NewValueHolder contents: self! !

Object subclass: #SpecBinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

SpecBinder class
	instanceVariableNames: 'bindings'!

!SpecBinder commentStamp: '<historical>' prior: 0!
A SpecBinder is a stupid dictionary where keys are spec symbolic name and values are corresponding spec class!

SpecBinder class
	instanceVariableNames: 'bindings'!

!SpecBinder class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/27/2012 09:59'!
initialize

	self initializeBindings! !

!SpecBinder class methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 4/24/2012 03:40'!
initializeBindings
	"self initializeBindings"
	bindings := IdentityDictionary new.
	bindings
		at: #ListSpec put: ListSpec;
		at: #MultiColumnListSpec put: MultiColumnListSpec;
		at: #IconListSpec put: IconListSpec;
		at: #RawSpec put: RawSpec;
		at: #ComposableSpec put: ComposableSpec;
		at: #TextSpec put: TextSpec;
		at: #ButtonSpec put: ButtonSpec;
		at: #CheckboxSpec put: CheckboxSpec;
		at: #DropListSpec put: DropListSpec;
		at: #LabelSpec put: LabelSpec;
		at: #TextFieldSpec put: TextFieldSpec;
		at: #TreeSpec put: TreeSpec.! !

!SpecBinder class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 01:55'!
specFor: aSymbol

	^ bindings at: aSymbol ! !

!SpecBinder class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 01:56'!
specFor: aSymbol ifAbsent: aBlock

	^ bindings at: aSymbol ifAbsent: aBlock! !

!SpecBinder methodsFor: 'see class side' stamp: 'BenjaminVanRyseghem 4/24/2012 03:37'!
seeClassSide! !

Object subclass: #SpecInterpreter
	instanceVariableNames: 'model spec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!SpecInterpreter commentStamp: '<historical>' prior: 0!
SpecInterpreter is the new Interpreter which now recognize different types of specs.

#model is a magic world to swap from the symbol to the model object
!

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
buildMorphFor: aComposableModel
	
	^ self new buildMorphFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self new buildMorphFor: aComposableModel withSpec: aSymbol! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
buildWindowFor: aComposableModel
	
	^ self new buildWindowFor: aComposableModel! !

!SpecInterpreter class methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/24/2012 10:39'!
interpretASpec: aSpec model: aModel
	
	^ self new
		interpretASpec: aSpec
		model: aModel! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 10:38'!
bindings
	
	^ model bindings! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
buildMorphFor: aComposableModel
	
	^ self buildMorphFor: aComposableModel withSpec: #internSpec! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
buildMorphFor: aComposableModel withSpec: aSymbol
	
	^ self interpretASpec: (aComposableModel class perform: aSymbol) model: aComposableModel! !

!SpecInterpreter methodsFor: 'building' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
buildWindowFor: aComposableModel
	
	^ self interpretASpec: aComposableModel class windowSpec model: aComposableModel! !

!SpecInterpreter methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
convertSymbolOfClassToInstance: aSymbol
	| symbol |
	
	symbol := self retrieveClassSymbolFor: aSymbol.
	
	^ (Smalltalk 
		at: symbol
		ifAbsent: [ ^ aSymbol ]) new! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'bvr 6/1/2012 17:14'!
interpretASpec: anArray
	| index |

	anArray ifNil: [ ^ nil ].
	(anArray isCollection and: [anArray isSequenceable]) ifFalse: [ ^ anArray ].
	(anArray isString or: [ anArray isText ]) ifTrue: [ 
			^ anArray == #model
				ifTrue: [ model ]
				ifFalse: [ self convertSymbolOfClassToInstance: anArray ]].

	" aSpec is an Array "
	"First element is a symbol describing the spec type"
	spec := self retreiveSpecFrom: anArray first.
	index := 2.	
	
	[ index <= anArray size ]
		whileTrue: [ | selector numArgs args newInstance |
			selector := spec bindings retrieveSelectorSymbolFor: (anArray at: index).
			selector isArray not
				ifTrue: [ 
					selector := selector asSymbol.
					numArgs := selector numArgs.
					args := anArray copyFrom: index + 1 to: index + numArgs.
					args := args collect: [:each | self class interpretASpec: each model: model ].
					index := index + numArgs + 1 ]
				ifFalse: [| array |
					"Here I assume that if it's not a symbol, it's a collection"
					array := selector.
					selector := array first.
					args := array allButFirst.
					args := args collect: [:each | self class interpretASpec: each model: model ].
					index := index + 1].
					newInstance := spec instance perform: selector withArguments: args.
			index > anArray size
				ifTrue: [
					| widget result |
					widget := spec instance.
					(model respondsTo: #widget:)
						ifTrue: [ model widget: widget ].
					result := self class interpretASpec: newInstance model: widget.
					(result isKindOf: ComposableModel)
						ifTrue: [ ^ result buildWithSpec ]
						ifFalse: [ ^ result ]].
				spec instance: newInstance ].
			
	"If you get here, there is a problem. Must probably it comes from the Spec which is wrongly defined"
	self assert: false.
	^ spec instance! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
interpretASpec: aSpec model: aModel
	
	self model: aModel.
	^ self interpretASpec: aSpec! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
model
	^ model! !

!SpecInterpreter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/24/2012 03:18'!
model: anObject
	model := anObject! !

!SpecInterpreter methodsFor: 'interpreting' stamp: 'BenjaminVanRyseghem 4/24/2012 10:46'!
retreiveSpecFrom: aSymbol
	| instance |
	instance :=  (SpecBinder 
			specFor: aSymbol 
			ifAbsent: [ ^ RawSpec new
							bindings: self bindings;
							defaultReceiver: aSymbol 
							model: model ]) new.
	^ instance 
		bindings: model bindings;
		yourself! !

!SpecInterpreter methodsFor: 'bindings' stamp: 'BenjaminVanRyseghem 4/24/2012 10:39'!
retrieveClassSymbolFor: aSymbol

	^ self bindings retrieveClassSymbolFor: aSymbol! !

Announcement subclass: #ValueChanged
	instanceVariableNames: 'newContents oldContents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Core'!

!ValueChanged commentStamp: '<historical>' prior: 0!
A ValueChanged is an announcement raised when a value of a NewValueHolder is changed!

!ValueChanged class methodsFor: 'instance creation' stamp: ''!
newContents: newContents

	^ self new
		newContents: newContents;
		yourself! !

!ValueChanged class methodsFor: 'instance creation' stamp: ''!
oldContents: oldContent newContents: newContent

	^ self new
		newContents: newContent;
		oldContents: oldContent;
		yourself! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
newContents

	^ newContents! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
newContents: anObject
	
	newContents := anObject! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
oldContents

	^ oldContents! !

!ValueChanged methodsFor: 'accessing' stamp: ''!
oldContents: anObject
	
	oldContents := anObject! !
SpecBinder initialize!
